package org.ow2.bonita.example.aw;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.ow2.bonita.env.GlobalEnvironmentFactory;

@SuppressWarnings("serial")
public class AWActions extends HttpServlet {

  public AWActions() {
    super();
  }

  public void destroy() {
    super.destroy();
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    response.setContentType("text/html");
    PrintWriter out = response.getWriter();
    AWCommon.writeStart(out);
    
    final String userName = request.getParameter("username");
    final String passWord = request.getParameter("password");
    
    String jaasLoginProp = "java.security.auth.login.config";
    String envProp = GlobalEnvironmentFactory.ENVIRONMENT_PROPERTY;
    
    if (System.getProperty(jaasLoginProp) == null) {
      String defaultJaasLogin = this.getClass().getClassLoader().getResource("jaas-login-tests.cfg").getPath();
      System.setProperty(jaasLoginProp, defaultJaasLogin);
      out.println("No jaas login property (" + jaasLoginProp 
          + ") has been defined. Using by default : " + defaultJaasLogin + "<br>");
    }
    
    if (System.getProperty(envProp) == null) {
      String defaultEnv = this.getClass().getClassLoader().getResource(GlobalEnvironmentFactory.DEFAULT_ENVIRONMENT).getPath();
      System.setProperty(envProp, defaultEnv);
      out.println("No environment property (" + envProp + ") has been defined. Using by default : " + defaultEnv + "<br>");
    }
    

    String formAction = AWCommon.ACTION_URL;
    
    String form = "";
    form += "<form name='deploy' method='get' action='" + formAction + "'><br>";
    form += "Path to Bar File  <input type='text' name='BarFile'>";
    form += "<input type='submit' name='deploy' value='Deploy' >";
    form += "<input type='hidden' name='Action' value='Deploy'>";
    form += formEnd(userName, passWord);
    
    form += "<br>";
    
    form += "<form name='start' method='get' action='" + formAction + "'><br>";
    form += "<input type='submit' name='startyes' value='Start with granted=yes' >";
    form += "<input type='hidden' name='Action' value='StartYes'>";
    form += formEnd(userName, passWord);
    
    form += "<br>";
    
    form += "<form name='start' method='get' action='" + formAction + "'><br>";
    form += "<input type='submit' name='startno' value='Start with granted=no' >";
    form += "<input type='hidden' name='Action' value='StartNo'>";
    form += formEnd(userName, passWord);
    
    form += "<br>";
    
    form += "<form name='deploy' method='get' action='" + formAction + "'><br>";
    form += "<input type='submit' name='undeploydelete' value='Undeploy/Delete' >";
    form += "<input type='hidden' name='Action' value='UndeployDelete'>";
    form += formEnd(userName, passWord);

    out.println(form);
    
    AWCommon.writeEnd(out);

    out.flush();
    out.close();
  }
  
  private String formEnd(String userName, String passWord) {
    String form = "";
    form += "<input type='hidden' name='username' value='" + userName + "'>";
    form += "<input type='hidden' name='password' value='" + passWord + "'>";
    form += "</form>";
    return form;
  }

  public void init() throws ServletException {

  }

}
